/*
 * FMDLog
 * Wideband O2 Display/Datalogging Application
 * For the TechEdge DIY-WB series of devices
 * (c) 2002-2003, Jonathan Burchmore
 *
 * Your use of this software is governed by the GNU General Public License, v2.
 * See the file COPYING.txt, or http://www.fsf.org/copyleft/gpl.txt
 *
 * This software is provided with ABSOLUTELY NO WARRANTY.  See the GNU General
 * public license for additional information.
 */

#include <PalmOS.h>
#include "resource.h"
#include "fmdlog.h"

/*
 * Smoothing Functions
 */

UInt32 smoothing_afr, smoothing_rpm, smoothing_v1, smoothing_v2, max_smoothing, skip_factor;

Boolean SmoothingForm_HandleEvent( EventPtr event )
{
	FormPtr frm;

	if ( event->eType == frmOpenEvent )
	{
		frm				= FrmGetActiveForm();

		Preferences_Set_Number( frm, textSmoothingAFR,	smoothing_afr );
		Preferences_Set_Number( frm, textSmoothingRPM,	smoothing_rpm );
		Preferences_Set_Number( frm, textSmoothingVu1,	smoothing_v1 );
		Preferences_Set_Number( frm, textSmoothingVu2,	smoothing_v2 );

		Preferences_Set_Number( frm, textSkipFactor,	skip_factor );

		FrmDrawForm( frm );
		return true;
	}
	else if ( event->eType == ctlSelectEvent )
	{
		if ( event->data.ctlSelect.controlID == buttonSmoothingSave )
		{
			frm				= FrmGetActiveForm();

			Preferences_Get_NumberU32( frm, textSmoothingAFR,	&smoothing_afr );
			Preferences_Get_NumberU32( frm, textSmoothingRPM,	&smoothing_rpm );
			Preferences_Get_NumberU32( frm, textSmoothingVu1,	&smoothing_v1 );
			Preferences_Get_NumberU32( frm, textSmoothingVu2,	&smoothing_v2 );

			Preferences_Get_NumberU32( frm, textSkipFactor,		&skip_factor );

													max_smoothing	= smoothing_afr;
			if ( smoothing_rpm > max_smoothing )	max_smoothing	= smoothing_rpm;
			if ( smoothing_v1 > max_smoothing )		max_smoothing	= smoothing_v1;
			if ( smoothing_v1 > max_smoothing )		max_smoothing	= smoothing_v2;

			replayrecord_visible_samples	= replayrecord_samples / ( skip_factor + 1 );

			if ( replayleftoffset > replayrecord_visible_samples - GRAPH_SAMPLES )	replayleftoffset	= replayrecord_visible_samples - GRAPH_SAMPLES;
			if ( replaycurrent >= replayleftoffset + GRAPH_SAMPLES )				replaycurrent		= replayleftoffset + GRAPH_SAMPLES - 1;

			Config_Save();
			FrmReturnToForm( 0 );
			LogReplayForm_Draw( 1 );

			return true;
		}
		else if ( event->data.ctlSelect.controlID == buttonSmoothingCancel )
		{
			FrmReturnToForm( 0 );
			return true;
		}
	}

	return false;
}

